## Channel Call stream interfaces Channel Call stream interfaces — client-side wrappers for call streams |

## Functions

TpProxyPendingCall * | tp_cli_call_stream_call_request_receiving ()
TpProxyPendingCall * | tp_cli_call_stream_call_set_sending ()
void | (*tp_cli_call_stream_callback_for_request_receiving) ()
void | (*tp_cli_call_stream_callback_for_set_sending) ()
TpProxySignalConnection * | tp_cli_call_stream_connect_to_local_sending_state_changed ()
TpProxySignalConnection * | tp_cli_call_stream_connect_to_remote_members_changed ()
void | (*tp_cli_call_stream_signal_callback_local_sending_state_changed) ()
void | (*tp_cli_call_stream_signal_callback_remote_members_changed) ()
TpProxyPendingCall * | tp_cli_call_stream_interface_media_call_add_candidates ()
TpProxyPendingCall * | tp_cli_call_stream_interface_media_call_complete_receiving_state_change ()
TpProxyPendingCall * | tp_cli_call_stream_interface_media_call_complete_sending_state_change ()
TpProxyPendingCall * | tp_cli_call_stream_interface_media_call_fail ()
TpProxyPendingCall * | tp_cli_call_stream_interface_media_call_finish_initial_candidates ()
TpProxyPendingCall * | tp_cli_call_stream_interface_media_call_report_receiving_failure ()
TpProxyPendingCall * | tp_cli_call_stream_interface_media_call_report_sending_failure ()
TpProxyPendingCall * | tp_cli_call_stream_interface_media_call_set_credentials ()
void | (*tp_cli_call_stream_interface_media_callback_for_add_candidates) ()
void | (*tp_cli_call_stream_interface_media_callback_for_complete_receiving_state_change) ()
void | (*tp_cli_call_stream_interface_media_callback_for_complete_sending_state_change) ()
void | (*tp_cli_call_stream_interface_media_callback_for_fail) ()
void | (*tp_cli_call_stream_interface_media_callback_for_finish_initial_candidates) ()
void | (*tp_cli_call_stream_interface_media_callback_for_report_receiving_failure) ()
void | (*tp_cli_call_stream_interface_media_callback_for_report_sending_failure) ()
void | (*tp_cli_call_stream_interface_media_callback_for_set_credentials) ()
TpProxySignalConnection * | tp_cli_call_stream_interface_media_connect_to_endpoints_changed ()
TpProxySignalConnection * | tp_cli_call_stream_interface_media_connect_to_ice_restart_requested ()
TpProxySignalConnection * | tp_cli_call_stream_interface_media_connect_to_local_candidates_added ()
TpProxySignalConnection * | tp_cli_call_stream_interface_media_connect_to_local_credentials_changed ()
TpProxySignalConnection * | tp_cli_call_stream_interface_media_connect_to_receiving_state_changed ()
TpProxySignalConnection * | tp_cli_call_stream_interface_media_connect_to_relay_info_changed ()
TpProxySignalConnection * | tp_cli_call_stream_interface_media_connect_to_sending_state_changed ()
TpProxySignalConnection * | tp_cli_call_stream_interface_media_connect_to_server_info_retrieved ()
TpProxySignalConnection * | tp_cli_call_stream_interface_media_connect_to_stun_servers_changed ()
void | (*tp_cli_call_stream_interface_media_signal_callback_endpoints_changed) ()
void | (*tp_cli_call_stream_interface_media_signal_callback_ice_restart_requested) ()
void | (*tp_cli_call_stream_interface_media_signal_callback_local_candidates_added) ()
void | (*tp_cli_call_stream_interface_media_signal_callback_local_credentials_changed) ()
void | (*tp_cli_call_stream_interface_media_signal_callback_receiving_state_changed) ()
void | (*tp_cli_call_stream_interface_media_signal_callback_relay_info_changed) ()
void | (*tp_cli_call_stream_interface_media_signal_callback_sending_state_changed) ()
void | (*tp_cli_call_stream_interface_media_signal_callback_server_info_retrieved) ()
void | (*tp_cli_call_stream_interface_media_signal_callback_stun_servers_changed) ()

## Includes

    #include <telepathy-glib/telepathy-glib-dbus.h>

## Description

Represents the streams of a call.

## Functions

### tp_cli_call_stream_call_request_receiving ()

    TpProxyPendingCall *
    tp_cli_call_stream_call_request_receiving
                                   (TpCallStream *proxy,
                                    gint timeout_ms,
                                    guint in_Contact,
                                    gboolean in_Receive,
                                    tp_cli_call_stream_callback_for_request_receiving callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a RequestReceiving method call.

<p>Request that a remote contact stops or starts sending on this stream.</p> <p>The <tp:member-ref>CanRequestReceiving</tp:member-ref> property defines whether the protocol allows the local user to request the other side start sending on this stream.</p>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Contact | Used to pass an 'in' argument: <tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Contact from which sending is requested</p> (TpContactHandle) |
in_Receive | Used to pass an 'in' argument: <tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>If true, request that the given contact starts to send media. If false, request that the given contact stops sending media.</p> |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_call_set_sending ()

    TpProxyPendingCall *
    tp_cli_call_stream_call_set_sending (TpCallStream *proxy,
                                         gint timeout_ms,
                                         gboolean in_Send,
                                         tp_cli_call_stream_callback_for_set_sending callback,
                                         gpointer user_data,
                                         GDestroyNotify destroy,
                                         GObject *weak_object);

Start a SetSending method call.

Set the stream to start or stop sending media from the local user to other contacts.

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Send | Used to pass an 'in' argument: <tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>If True, the <tp:member-ref>LocalSendingState</tp:member-ref> should change to <tp:value-ref type="Sending_State">Sending</tp:value-ref>, if it isn't already.</p> <p>If False, the <tp:member-ref>LocalSendingState</tp:member-ref> should change to <tp:value-ref type="Sending_State">None</tp:value-ref>, if it isn't already.</p> |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_callback_for_request_receiving ()

    void
    (*tp_cli_call_stream_callback_for_request_receiving)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a RequestReceiving method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_callback_for_set_sending ()

    void
    (*tp_cli_call_stream_callback_for_set_sending)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a SetSending method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_connect_to_local_sending_state_changed ()

    TpProxySignalConnection *
    tp_cli_call_stream_connect_to_local_sending_state_changed
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_signal_callback_local_sending_state_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal LocalSendingStateChanged.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> Emitted when <tp:member-ref>LocalSendingState</tp:member-ref> changes.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_connect_to_remote_members_changed ()

    TpProxySignalConnection *
    tp_cli_call_stream_connect_to_remote_members_changed
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_signal_callback_remote_members_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal RemoteMembersChanged.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> Emitted when <tp:member-ref>RemoteMembers</tp:member-ref> changes.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_signal_callback_local_sending_state_changed ()

    void
    (*tp_cli_call_stream_signal_callback_local_sending_state_changed)
                                   (TpCallStream *proxy,
                                    guint arg_State,
                                    const GValueArray *arg_Reason,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal LocalSendingStateChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_connect_to_local_sending_state_changed()` was called |
arg_State | The new value of <tp:member-ref>LocalSendingState</tp:member-ref>. (TpSendingState) |
arg_Reason | A structured reason for the change. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_signal_callback_remote_members_changed ()

    void
    (*tp_cli_call_stream_signal_callback_remote_members_changed)
                                   (TpCallStream *proxy,
                                    GHashTable *arg_Updates,
                                    GHashTable *arg_Identifiers,
                                    const GArray *arg_Removed,
                                    const GValueArray *arg_Reason,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal RemoteMembersChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_connect_to_remote_members_changed()` was called |
arg_Updates | A mapping from channel-specific handles to their updated sending state, whose keys include at least the members who were added, and the members whose states changed. |
arg_Identifiers | <tp:docstring xmlns="http://www.w3.org/1999/xhtml"> The identifiers of the contacts in the <var>Updates</var> map. |
arg_Removed | The channel-specific handles that were removed from the keys of the <tp:member-ref>RemoteMembers</tp:member-ref> property, as a result of the contact leaving this stream |
arg_Reason | A structured reason for the change. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_interface_media_call_add_candidates ()

    TpProxyPendingCall *
    tp_cli_call_stream_interface_media_call_add_candidates
                                   (TpCallStream *proxy,
                                    gint timeout_ms,
                                    const GPtrArray *in_Candidates,
                                    tp_cli_call_stream_interface_media_callback_for_add_candidates callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a AddCandidates method call.

Add candidates to the <tp:member-ref>LocalCandidates</tp:member-ref> property and signal them to the remote contact(s). Note that connection managers MAY delay the sending of candidates until <tp:member-ref>FinishInitialCandidates</tp:member-ref> is called.

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Candidates | Used to pass an 'in' argument: The candidates to be added. |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_interface_media_call_complete_receiving_state_change ()

    TpProxyPendingCall *
    tp_cli_call_stream_interface_media_call_complete_receiving_state_change
                                   (TpCallStream *proxy,
                                    gint timeout_ms,
                                    guint in_State,
                                    tp_cli_call_stream_interface_media_callback_for_complete_receiving_state_change callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a CompleteReceivingStateChange method call.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Called in response to <tp:member-ref>ReceivingStateChanged</tp:member-ref>(Pending_*, *) to indicate that the media state has successfully progressed from Pending_{Start, Stop, Pause} to the corresponding non-pending state.</p>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_State | Used to pass an 'in' argument: The new (non-pending) value of ReceivingState. (TpStreamFlowState) |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_interface_media_call_complete_sending_state_change ()

    TpProxyPendingCall *
    tp_cli_call_stream_interface_media_call_complete_sending_state_change
                                   (TpCallStream *proxy,
                                    gint timeout_ms,
                                    guint in_State,
                                    tp_cli_call_stream_interface_media_callback_for_complete_sending_state_change callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a CompleteSendingStateChange method call.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Called in response to <tp:member-ref>SendingStateChanged</tp:member-ref>(Pending_*, *) to indicate that the media state has successfully progressed from Pending_{Start, Stop, Pause} to the corresponding non-pending state.</p>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_State | Used to pass an 'in' argument: The new (non-pending) value of SendingState. (TpStreamFlowState) |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_interface_media_call_fail ()

    TpProxyPendingCall *
    tp_cli_call_stream_interface_media_call_fail
                                   (TpCallStream *proxy,
                                    gint timeout_ms,
                                    const GValueArray *in_Reason,
                                    tp_cli_call_stream_interface_media_callback_for_fail callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a Fail method call.

Signal an unrecoverable error for this stream, and remove it. If all streams are removed from a content, then it will also be removed.

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Reason | Used to pass an 'in' argument: A structured reason for stream removal. |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_interface_media_call_finish_initial_candidates ()

    TpProxyPendingCall *
    tp_cli_call_stream_interface_media_call_finish_initial_candidates
                                   (TpCallStream *proxy,
                                    gint timeout_ms,
                                    tp_cli_call_stream_interface_media_callback_for_finish_initial_candidates callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a FinishInitialCandidates method call.

This indicates to the CM that the initial batch of candidates has been added, and should now be processed/sent to the remote side. <tp:rationale> Protocols supporting Raw UDP SHOULD wait for FinishInitialCandidates, and then set the lowest priority candidate as the Raw UDP candidate. </tp:rationale>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_interface_media_call_report_receiving_failure ()

    TpProxyPendingCall *
    tp_cli_call_stream_interface_media_call_report_receiving_failure
                                   (TpCallStream *proxy,
                                    gint timeout_ms,
                                    guint in_Reason,
                                    const gchar *in_Error,
                                    const gchar *in_Message,
                                    tp_cli_call_stream_interface_media_callback_for_report_receiving_failure callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a ReportReceivingFailure method call.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> Can be called at any point to indicate a failure in the incoming portion of the stream.

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Reason | Used to pass an 'in' argument: (Undocumented) (TpCallStateChangeReason) |
in_Error | Used to pass an 'in' argument: (Undocumented) |
in_Message | Used to pass an 'in' argument: (Undocumented) |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_interface_media_call_report_sending_failure ()

    TpProxyPendingCall *
    tp_cli_call_stream_interface_media_call_report_sending_failure
                                   (TpCallStream *proxy,
                                    gint timeout_ms,
                                    guint in_Reason,
                                    const gchar *in_Error,
                                    const gchar *in_Message,
                                    tp_cli_call_stream_interface_media_callback_for_report_sending_failure callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a ReportSendingFailure method call.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> Can be called at any point to indicate a failure in the outgoing portion of the stream.

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Reason | Used to pass an 'in' argument: (Undocumented) (TpCallStateChangeReason) |
in_Error | Used to pass an 'in' argument: (Undocumented) |
in_Message | Used to pass an 'in' argument: (Undocumented) |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_interface_media_call_set_credentials ()

    TpProxyPendingCall *
    tp_cli_call_stream_interface_media_call_set_credentials
                                   (TpCallStream *proxy,
                                    gint timeout_ms,
                                    const gchar *in_Username,
                                    const gchar *in_Password,
                                    tp_cli_call_stream_interface_media_callback_for_set_credentials callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object);

Start a SetCredentials method call.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Used to set the username fragment and password for streams that have global credentials.</p>

#### Parameters

proxy | the TpProxy |
timeout_ms | the timeout in milliseconds, or -1 to use the default |
in_Username | Used to pass an 'in' argument: The username to use when authenticating on the stream. |
in_Password | Used to pass an 'in' argument: The password to use when authenticating on the stream. |
callback | called when the method call succeeds or fails; may be `NULL` to make a "fire and forget" call with no reply tracking |
user_data | user-supplied data passed to the callback; must be `NULL` if `callback` is `NULL` |
destroy | called with the user_data as argument, after the call has succeeded, failed or been cancelled; must be `NULL` if `callback` is `NULL` |
weak_object | If not `NULL`, a GObject which will be weakly referenced; if it is destroyed, this call will automatically be cancelled. Must be `NULL` if `callback` is `NULL` |

#### Returns

a TpProxyPendingCall representing the call in progress. It is borrowed from the object, and will become invalid when the callback is called, the call is cancelled or the TpProxy becomes invalid.

### tp_cli_call_stream_interface_media_callback_for_add_candidates ()

    void
    (*tp_cli_call_stream_interface_media_callback_for_add_candidates)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a AddCandidates method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_interface_media_callback_for_complete_receiving_state_change ()

    void
    (*tp_cli_call_stream_interface_media_callback_for_complete_receiving_state_change)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a CompleteReceivingStateChange method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_interface_media_callback_for_complete_sending_state_change ()

    void
    (*tp_cli_call_stream_interface_media_callback_for_complete_sending_state_change)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a CompleteSendingStateChange method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_interface_media_callback_for_fail ()

    void
    (*tp_cli_call_stream_interface_media_callback_for_fail)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a Fail method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_interface_media_callback_for_finish_initial_candidates ()

    void
    (*tp_cli_call_stream_interface_media_callback_for_finish_initial_candidates)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a FinishInitialCandidates method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_interface_media_callback_for_report_receiving_failure ()

    void
    (*tp_cli_call_stream_interface_media_callback_for_report_receiving_failure)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a ReportReceivingFailure method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_interface_media_callback_for_report_sending_failure ()

    void
    (*tp_cli_call_stream_interface_media_callback_for_report_sending_failure)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a ReportSendingFailure method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_interface_media_callback_for_set_credentials ()

    void
    (*tp_cli_call_stream_interface_media_callback_for_set_credentials)
                                   (TpCallStream *proxy,
                                    const GError *error,
                                    gpointer user_data,
                                    GObject *weak_object);

Signature of the callback called when a SetCredentials method call succeeds or fails.

#### Parameters

proxy | the proxy on which the call was made |
error | `NULL` on success, or an error on failure |
user_data | user-supplied data |
weak_object | user-supplied object |

### tp_cli_call_stream_interface_media_connect_to_endpoints_changed ()

    TpProxySignalConnection *
    tp_cli_call_stream_interface_media_connect_to_endpoints_changed
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_interface_media_signal_callback_endpoints_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal EndpointsChanged.

Emitted when the <tp:member-ref>Endpoints</tp:member-ref> property changes.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_interface_media_connect_to_ice_restart_requested ()

    TpProxySignalConnection *
    tp_cli_call_stream_interface_media_connect_to_ice_restart_requested
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_interface_media_signal_callback_ice_restart_requested callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal ICERestartRequested.

Emitted when the remote side requests an ICE restart (e.g. third party call control, when the remote endpoint changes). The streaming implementation should call <tp:member-ref>SetCredentials</tp:member-ref> again.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_interface_media_connect_to_local_candidates_added ()

    TpProxySignalConnection *
    tp_cli_call_stream_interface_media_connect_to_local_candidates_added
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_interface_media_signal_callback_local_candidates_added callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal LocalCandidatesAdded.

Emitted when local candidates are added to the <tp:member-ref>LocalCandidates</tp:member-ref> property.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_interface_media_connect_to_local_credentials_changed ()

    TpProxySignalConnection *
    tp_cli_call_stream_interface_media_connect_to_local_credentials_changed
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_interface_media_signal_callback_local_credentials_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal LocalCredentialsChanged.

Emitted when the value of <tp:member-ref>LocalCredentials</tp:member-ref> changes to a non-empty value. This should only happen when the streaming implementation calls <tp:member-ref>SetCredentials</tp:member-ref>, so this signal is mostly useful for debugging.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_interface_media_connect_to_receiving_state_changed ()

    TpProxySignalConnection *
    tp_cli_call_stream_interface_media_connect_to_receiving_state_changed
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_interface_media_signal_callback_receiving_state_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal ReceivingStateChanged.

Change notification for <tp:member-ref>ReceivingState</tp:member-ref>.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_interface_media_connect_to_relay_info_changed ()

    TpProxySignalConnection *
    tp_cli_call_stream_interface_media_connect_to_relay_info_changed
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_interface_media_signal_callback_relay_info_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal RelayInfoChanged.

Emitted when the value of <tp:member-ref>RelayInfo</tp:member-ref> changes.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_interface_media_connect_to_sending_state_changed ()

    TpProxySignalConnection *
    tp_cli_call_stream_interface_media_connect_to_sending_state_changed
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_interface_media_signal_callback_sending_state_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal SendingStateChanged.

Change notification for <tp:member-ref>SendingState</tp:member-ref>. Note that this information is duplicated onto the Stream interface, so that UIs can ignore the Media interface, and streaming implementations can ignore everything but the media interface.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_interface_media_connect_to_server_info_retrieved ()

    TpProxySignalConnection *
    tp_cli_call_stream_interface_media_connect_to_server_info_retrieved
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_interface_media_signal_callback_server_info_retrieved callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal ServerInfoRetrieved.

<tp:docstring xmlns="http://www.w3.org/1999/xhtml"> <p>Signals that the initial information about STUN and Relay servers has been retrieved, i.e. the <tp:member-ref>HasServerInfo</tp:member-ref> property is now true.</p>

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_interface_media_connect_to_stun_servers_changed ()

    TpProxySignalConnection *
    tp_cli_call_stream_interface_media_connect_to_stun_servers_changed
                                   (TpCallStream *proxy,
                                    tp_cli_call_stream_interface_media_signal_callback_stun_servers_changed callback,
                                    gpointer user_data,
                                    GDestroyNotify destroy,
                                    GObject *weak_object,
                                    GError **error);

Connect a handler to the signal STUNServersChanged.

Emitted when the value of <tp:member-ref>STUNServers</tp:member-ref> changes.

#### Parameters

proxy | A TpCallStream or subclass |
callback | Callback to be called when the signal is received |
user_data | User-supplied data for the callback |
destroy | Destructor for the user-supplied data, which will be called when this signal is disconnected, or before this function returns `NULL` |
weak_object | A GObject which will be weakly referenced; if it is destroyed, this callback will automatically be disconnected |
error | If not `NULL`, used to raise an error if `NULL` is returned |

#### Returns

a TpProxySignalConnection containing all of the above, which can be used to disconnect the signal; or `NULL` if the proxy does not have the desired interface or has become invalid.

### tp_cli_call_stream_interface_media_signal_callback_endpoints_changed ()

    void
    (*tp_cli_call_stream_interface_media_signal_callback_endpoints_changed)
                                   (TpCallStream *proxy,
                                    const GPtrArray *arg_Endpoints_Added,
                                    const GPtrArray *arg_Endpoints_Removed,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal EndpointsChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_interface_media_connect_to_endpoints_changed()` was called |
arg_Endpoints_Added | Endpoints that were added. |
arg_Endpoints_Removed | Endpoints that no longer exist. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_interface_media_signal_callback_ice_restart_requested ()

    void
    (*tp_cli_call_stream_interface_media_signal_callback_ice_restart_requested)
                                   (TpCallStream *proxy,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal ICERestartRequested.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_interface_media_connect_to_ice_restart_requested()` was called |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_interface_media_signal_callback_local_candidates_added ()

    void
    (*tp_cli_call_stream_interface_media_signal_callback_local_candidates_added)
                                   (TpCallStream *proxy,
                                    const GPtrArray *arg_Candidates,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal LocalCandidatesAdded.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_interface_media_connect_to_local_candidates_added()` was called |
arg_Candidates | Candidates that have been added. |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_interface_media_signal_callback_local_credentials_changed ()

    void
    (*tp_cli_call_stream_interface_media_signal_callback_local_credentials_changed)
                                   (TpCallStream *proxy,
                                    const gchar *arg_Username,
                                    const gchar *arg_Password,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal LocalCredentialsChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_interface_media_connect_to_local_credentials_changed()` was called |
arg_Username | . | [Undocumented]
arg_Password | . | [Undocumented]
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_interface_media_signal_callback_receiving_state_changed ()

    void
    (*tp_cli_call_stream_interface_media_signal_callback_receiving_state_changed)
                                   (TpCallStream *proxy,
                                    guint arg_State,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal ReceivingStateChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_interface_media_connect_to_receiving_state_changed()` was called |
arg_State | The new value of ReceivingState. (TpStreamFlowState) |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_interface_media_signal_callback_relay_info_changed ()

    void
    (*tp_cli_call_stream_interface_media_signal_callback_relay_info_changed)
                                   (TpCallStream *proxy,
                                    const GPtrArray *arg_Relay_Info,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal RelayInfoChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_interface_media_connect_to_relay_info_changed()` was called |
arg_Relay_Info | . | [Undocumented]
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_interface_media_signal_callback_sending_state_changed ()

    void
    (*tp_cli_call_stream_interface_media_signal_callback_sending_state_changed)
                                   (TpCallStream *proxy,
                                    guint arg_State,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal SendingStateChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_interface_media_connect_to_sending_state_changed()` was called |
arg_State | The new value of SendingState. (TpStreamFlowState) |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_interface_media_signal_callback_server_info_retrieved ()

    void
    (*tp_cli_call_stream_interface_media_signal_callback_server_info_retrieved)
                                   (TpCallStream *proxy,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal ServerInfoRetrieved.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_interface_media_connect_to_server_info_retrieved()` was called |
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |

### tp_cli_call_stream_interface_media_signal_callback_stun_servers_changed ()

    void
    (*tp_cli_call_stream_interface_media_signal_callback_stun_servers_changed)
                                   (TpCallStream *proxy,
                                    const GPtrArray *arg_Servers,
                                    gpointer user_data,
                                    GObject *weak_object);

Represents the signature of a callback for the signal STUNServersChanged.

#### Parameters

proxy | The proxy on which `tp_cli_call_stream_interface_media_connect_to_stun_servers_changed()` was called |
arg_Servers | . | [Undocumented]
user_data | User-supplied data |
weak_object | User-supplied weakly referenced object |